# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::OperationalInsights::Mgmt::V2015_03_20
  module Models
    #
    # Value object for saved search results.
    #
    class SavedSearch

      include MsRestAzure

      # @return [String] The id of the saved search.
      attr_accessor :id

      # @return [String] The name of the saved search.
      attr_accessor :name

      # @return [String] The type of the saved search.
      attr_accessor :type

      # @return [String] The ETag of the saved search.
      attr_accessor :e_tag

      # @return [String] The category of the saved search. This helps the user
      # to find a saved search faster.
      attr_accessor :category

      # @return [String] Saved search display name.
      attr_accessor :display_name

      # @return [String] The query expression for the saved search. Please see
      # https://docs.microsoft.com/en-us/azure/log-analytics/log-analytics-search-reference
      # for reference.
      attr_accessor :query

      # @return [Integer] The version number of the query language. The current
      # version is 2 and is the default.
      attr_accessor :version

      # @return [Array<Tag>] The tags attached to the saved search.
      attr_accessor :tags


      #
      # Mapper for SavedSearch class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'SavedSearch',
          type: {
            name: 'Composite',
            class_name: 'SavedSearch',
            model_properties: {
              id: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'id',
                type: {
                  name: 'String'
                }
              },
              name: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'name',
                type: {
                  name: 'String'
                }
              },
              type: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'type',
                type: {
                  name: 'String'
                }
              },
              e_tag: {
                client_side_validation: true,
                required: false,
                serialized_name: 'eTag',
                type: {
                  name: 'String'
                }
              },
              category: {
                client_side_validation: true,
                required: true,
                serialized_name: 'properties.category',
                type: {
                  name: 'String'
                }
              },
              display_name: {
                client_side_validation: true,
                required: true,
                serialized_name: 'properties.displayName',
                type: {
                  name: 'String'
                }
              },
              query: {
                client_side_validation: true,
                required: true,
                serialized_name: 'properties.query',
                type: {
                  name: 'String'
                }
              },
              version: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.version',
                constraints: {
                  InclusiveMaximum: 2,
                  InclusiveMinimum: 1
                },
                type: {
                  name: 'Number'
                }
              },
              tags: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.tags',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'TagElementType',
                      type: {
                        name: 'Composite',
                        class_name: 'Tag'
                      }
                  }
                }
              }
            }
          }
        }
      end
    end
  end
end
