# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::OperationalInsights::Mgmt::V2020_08_01
  module Models
    #
    # The top level Log Analytics cluster resource container.
    #
    class Cluster < TrackedResource

      include MsRestAzure

      # @return [Identity] The identity of the resource.
      attr_accessor :identity

      # @return [ClusterSku] The sku properties.
      attr_accessor :sku

      # @return [String] The link used to get the next page of recommendations.
      attr_accessor :next_link

      # @return [String] The ID associated with the cluster.
      attr_accessor :cluster_id

      # @return [ClusterEntityStatus] The provisioning state of the cluster.
      # Possible values include: 'Creating', 'Succeeded', 'Failed', 'Canceled',
      # 'Deleting', 'ProvisioningAccount', 'Updating'
      attr_accessor :provisioning_state

      # @return [KeyVaultProperties] The associated key properties.
      attr_accessor :key_vault_properties


      #
      # Mapper for Cluster class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'Cluster',
          type: {
            name: 'Composite',
            class_name: 'Cluster',
            model_properties: {
              id: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'id',
                type: {
                  name: 'String'
                }
              },
              name: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'name',
                type: {
                  name: 'String'
                }
              },
              type: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'type',
                type: {
                  name: 'String'
                }
              },
              tags: {
                client_side_validation: true,
                required: false,
                serialized_name: 'tags',
                type: {
                  name: 'Dictionary',
                  value: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'StringElementType',
                      type: {
                        name: 'String'
                      }
                  }
                }
              },
              location: {
                client_side_validation: true,
                required: true,
                serialized_name: 'location',
                type: {
                  name: 'String'
                }
              },
              identity: {
                client_side_validation: true,
                required: false,
                serialized_name: 'identity',
                type: {
                  name: 'Composite',
                  class_name: 'Identity'
                }
              },
              sku: {
                client_side_validation: true,
                required: false,
                serialized_name: 'sku',
                type: {
                  name: 'Composite',
                  class_name: 'ClusterSku'
                }
              },
              next_link: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.nextLink',
                type: {
                  name: 'String'
                }
              },
              cluster_id: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.clusterId',
                type: {
                  name: 'String'
                }
              },
              provisioning_state: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.provisioningState',
                type: {
                  name: 'String'
                }
              },
              key_vault_properties: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.keyVaultProperties',
                type: {
                  name: 'Composite',
                  class_name: 'KeyVaultProperties'
                }
              }
            }
          }
        }
      end
    end
  end
end
