# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::OperationalInsights::Mgmt::V2020_08_01
  module Models
    #
    # The top level Linked service resource container.
    #
    class LinkedService < ProxyResource

      include MsRestAzure

      # @return [String] The resource id of the resource that will be linked to
      # the workspace. This should be used for linking resources which require
      # read access
      attr_accessor :resource_id

      # @return [String] The resource id of the resource that will be linked to
      # the workspace. This should be used for linking resources which require
      # write access
      attr_accessor :write_access_resource_id

      # @return [LinkedServiceEntityStatus] The provisioning state of the
      # linked service. Possible values include: 'Succeeded', 'Deleting',
      # 'ProvisioningAccount', 'Updating'
      attr_accessor :provisioning_state

      # @return [Hash{String => String}] Resource tags.
      attr_accessor :tags


      #
      # Mapper for LinkedService class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'LinkedService',
          type: {
            name: 'Composite',
            class_name: 'LinkedService',
            model_properties: {
              id: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'id',
                type: {
                  name: 'String'
                }
              },
              name: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'name',
                type: {
                  name: 'String'
                }
              },
              type: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'type',
                type: {
                  name: 'String'
                }
              },
              resource_id: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.resourceId',
                type: {
                  name: 'String'
                }
              },
              write_access_resource_id: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.writeAccessResourceId',
                type: {
                  name: 'String'
                }
              },
              provisioning_state: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.provisioningState',
                type: {
                  name: 'String'
                }
              },
              tags: {
                client_side_validation: true,
                required: false,
                serialized_name: 'tags',
                type: {
                  name: 'Dictionary',
                  value: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'StringElementType',
                      type: {
                        name: 'String'
                      }
                  }
                }
              }
            }
          }
        }
      end
    end
  end
end
