# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::OperationalInsights::Mgmt::V2020_08_01
  module Models
    #
    # Value object for saved search results.
    #
    class SavedSearch < ProxyResource

      include MsRestAzure

      # @return [String] The ETag of the saved search.
      attr_accessor :etag

      # @return [String] The category of the saved search. This helps the user
      # to find a saved search faster.
      attr_accessor :category

      # @return [String] Saved search display name.
      attr_accessor :display_name

      # @return [String] The query expression for the saved search.
      attr_accessor :query

      # @return [String] The function alias if query serves as a function.
      attr_accessor :function_alias

      # @return [String] The optional function parameters if query serves as a
      # function. Value should be in the following format: 'param-name1:type1 =
      # default_value1, param-name2:type2 = default_value2'. For more examples
      # and proper syntax please refer to
      # https://docs.microsoft.com/en-us/azure/kusto/query/functions/user-defined-functions.
      attr_accessor :function_parameters

      # @return [Integer] The version number of the query language. The current
      # version is 2 and is the default.
      attr_accessor :version

      # @return [Array<Tag>] The tags attached to the saved search.
      attr_accessor :tags


      #
      # Mapper for SavedSearch class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'SavedSearch',
          type: {
            name: 'Composite',
            class_name: 'SavedSearch',
            model_properties: {
              id: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'id',
                type: {
                  name: 'String'
                }
              },
              name: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'name',
                type: {
                  name: 'String'
                }
              },
              type: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'type',
                type: {
                  name: 'String'
                }
              },
              etag: {
                client_side_validation: true,
                required: false,
                serialized_name: 'etag',
                type: {
                  name: 'String'
                }
              },
              category: {
                client_side_validation: true,
                required: true,
                serialized_name: 'properties.category',
                type: {
                  name: 'String'
                }
              },
              display_name: {
                client_side_validation: true,
                required: true,
                serialized_name: 'properties.displayName',
                type: {
                  name: 'String'
                }
              },
              query: {
                client_side_validation: true,
                required: true,
                serialized_name: 'properties.query',
                type: {
                  name: 'String'
                }
              },
              function_alias: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.functionAlias',
                type: {
                  name: 'String'
                }
              },
              function_parameters: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.functionParameters',
                type: {
                  name: 'String'
                }
              },
              version: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.version',
                type: {
                  name: 'Number'
                }
              },
              tags: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.tags',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'TagElementType',
                      type: {
                        name: 'Composite',
                        class_name: 'Tag'
                      }
                  }
                }
              }
            }
          }
        }
      end
    end
  end
end
