# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::OperationalInsights::Mgmt::V2020_08_01
  module Models
    #
    # The top level storage insight resource container.
    #
    class StorageInsight < ProxyResource

      include MsRestAzure

      # @return [Array<String>] The names of the blob containers that the
      # workspace should read
      attr_accessor :containers

      # @return [Array<String>] The names of the Azure tables that the
      # workspace should read
      attr_accessor :tables

      # @return [StorageAccount] The storage account connection details
      attr_accessor :storage_account

      # @return [StorageInsightStatus] The status of the storage insight
      attr_accessor :status

      # @return [String] The ETag of the storage insight.
      attr_accessor :e_tag

      # @return [Hash{String => String}] Resource tags.
      attr_accessor :tags


      #
      # Mapper for StorageInsight class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'StorageInsight',
          type: {
            name: 'Composite',
            class_name: 'StorageInsight',
            model_properties: {
              id: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'id',
                type: {
                  name: 'String'
                }
              },
              name: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'name',
                type: {
                  name: 'String'
                }
              },
              type: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'type',
                type: {
                  name: 'String'
                }
              },
              containers: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.containers',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'StringElementType',
                      type: {
                        name: 'String'
                      }
                  }
                }
              },
              tables: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.tables',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'StringElementType',
                      type: {
                        name: 'String'
                      }
                  }
                }
              },
              storage_account: {
                client_side_validation: true,
                required: true,
                serialized_name: 'properties.storageAccount',
                type: {
                  name: 'Composite',
                  class_name: 'StorageAccount'
                }
              },
              status: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.status',
                type: {
                  name: 'Composite',
                  class_name: 'StorageInsightStatus'
                }
              },
              e_tag: {
                client_side_validation: true,
                required: false,
                serialized_name: 'eTag',
                type: {
                  name: 'String'
                }
              },
              tags: {
                client_side_validation: true,
                required: false,
                serialized_name: 'tags',
                type: {
                  name: 'Dictionary',
                  value: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'StringElementType',
                      type: {
                        name: 'String'
                      }
                  }
                }
              }
            }
          }
        }
      end
    end
  end
end
